"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactNative = require("react-native");
const CryptoAlgorithmNative = _reactNative.NativeModules.CryptoAlgorithm;
class Crypto {
  static hashSHA256 = value => {
    return CryptoAlgorithmNative.hashSHA256(value);
  };
  static encryptAES = (value, secretKey, ivKey) => {
    return CryptoAlgorithmNative.encryptAES(value, secretKey, ivKey);
  };
  static decryptAES = (value, secretKey, ivKey) => {
    return CryptoAlgorithmNative.decryptAES(value, secretKey, ivKey);
  };
  static genRSAKeyPair = () => {
    return CryptoAlgorithmNative.genRSAKeyPair();
  };
  static encryptRSA = (value, publicKey) => {
    return CryptoAlgorithmNative.encryptRSA(value, publicKey);
  };
  static decryptRSA = (value, privateKey) => {
    return CryptoAlgorithmNative.decryptRSA(value, privateKey);
  };
  static genHmacSecretKey = () => {
    return CryptoAlgorithmNative.genSecretKey('Hmac');
  };
  static encryptHmacAes = (value, privateKey) => {
    return CryptoAlgorithmNative.encryptHmacAes(value, privateKey);
  };
  static decryptHmacAes = (value, privateKey) => {
    return CryptoAlgorithmNative.decryptHmacAes(value, privateKey);
  };
  static verifyHmac = (value, privateKey) => {
    return CryptoAlgorithmNative.verifyHmac(value, privateKey);
  };
}
exports.default = Crypto;
//# sourceMappingURL=index.js.map